<!DOCTYPE html>

<html lang="en" data-content_root="../../">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>src.inout &#8212; pandas 2.1.1 documentation</title>
    <link rel="stylesheet" type="text/css" href="../../_static/pygments.css?v=fa44fd50" />
    <link rel="stylesheet" type="text/css" href="../../_static/alabaster.css?v=233b9934" />
    <script src="../../_static/documentation_options.js?v=841abef3"></script>
    <script src="../../_static/doctools.js?v=888ff710"></script>
    <script src="../../_static/sphinx_highlight.js?v=dc90522c"></script>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
   
  <link rel="stylesheet" href="../../_static/custom.css" type="text/css" />
  
  
  <meta name="viewport" content="width=device-width, initial-scale=0.9, maximum-scale=0.9" />

  </head><body>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          

          <div class="body" role="main">
            
  <h1>Source code for src.inout</h1><div class="highlight"><pre>
<span></span><span class="kn">from</span> <span class="nn">.common</span> <span class="kn">import</span> <span class="n">generator</span><span class="p">,</span> <span class="n">processor</span><span class="p">,</span> <span class="n">params_to_dict</span>
<span class="kn">import</span> <span class="nn">logging</span>
<span class="kn">import</span> <span class="nn">os</span>
<span class="kn">import</span> <span class="nn">click</span>
<span class="kn">import</span> <span class="nn">pandas</span> <span class="k">as</span> <span class="nn">pd</span>
<span class="kn">import</span> <span class="nn">panel</span> <span class="k">as</span> <span class="nn">pn</span>
<span class="kn">from</span> <span class="nn">functools</span> <span class="kn">import</span> <span class="n">update_wrapper</span>


<div class="viewcode-block" id="to_html">
<a class="viewcode-back" href="../../api/src.html#src.inout.to_html">[docs]</a>
<span class="k">def</span> <span class="nf">to_html</span><span class="p">(</span><span class="n">ofile</span><span class="p">,</span> <span class="n">df</span><span class="p">,</span> <span class="o">**</span><span class="n">kwds</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;Writes the dataframe to an interactive HTML table.&quot;&quot;&quot;</span>
    <span class="c1"># Uses panel (https://panel.holoviz.org/)</span>
    <span class="c1"># df denotes your existing pandas DataFrame</span>
    <span class="n">df</span> <span class="o">=</span> <span class="n">pn</span><span class="o">.</span><span class="n">widgets</span><span class="o">.</span><span class="n">Tabulator</span><span class="p">(</span><span class="n">df</span><span class="p">)</span>
    <span class="c1"># df.datetime = df.datetime.astype(str)</span>
    <span class="n">df</span><span class="o">.</span><span class="n">save</span><span class="p">(</span><span class="n">ofile</span><span class="p">)</span></div>



<span class="n">CONFIG</span> <span class="o">=</span> <span class="p">{</span>
    <span class="s2">&quot;readers&quot;</span><span class="p">:</span> <span class="p">{</span>
        <span class="s2">&quot;.csv&quot;</span><span class="p">:</span> <span class="n">update_wrapper</span><span class="p">(</span>
            <span class="k">lambda</span> <span class="n">filename</span><span class="p">,</span> <span class="o">**</span><span class="n">kwds</span><span class="p">:</span> <span class="n">pd</span><span class="o">.</span><span class="n">read_csv</span><span class="p">(</span><span class="n">filename</span><span class="p">,</span> <span class="o">**</span><span class="n">kwds</span><span class="p">),</span>
            <span class="n">pd</span><span class="o">.</span><span class="n">read_csv</span><span class="p">),</span>
        <span class="s2">&quot;.pkl&quot;</span><span class="p">:</span> <span class="n">update_wrapper</span><span class="p">(</span>
            <span class="k">lambda</span> <span class="n">filename</span><span class="p">,</span> <span class="o">**</span><span class="n">kwds</span><span class="p">:</span> <span class="n">pd</span><span class="o">.</span><span class="n">read_pickle</span><span class="p">(</span><span class="n">filename</span><span class="p">,</span> <span class="o">**</span><span class="n">kwds</span><span class="p">),</span>
            <span class="n">pd</span><span class="o">.</span><span class="n">read_pickle</span><span class="p">),</span>
        <span class="s2">&quot;.txt&quot;</span><span class="p">:</span> <span class="n">update_wrapper</span><span class="p">(</span>
            <span class="k">lambda</span> <span class="n">filename</span><span class="p">,</span> <span class="o">**</span><span class="n">kwds</span><span class="p">:</span> <span class="n">pd</span><span class="o">.</span><span class="n">read_table</span><span class="p">(</span><span class="n">filename</span><span class="p">,</span> <span class="o">**</span><span class="n">kwds</span><span class="p">),</span>
            <span class="n">pd</span><span class="o">.</span><span class="n">read_table</span><span class="p">),</span>
        <span class="s2">&quot;.xlsx&quot;</span><span class="p">:</span> <span class="n">update_wrapper</span><span class="p">(</span>
            <span class="k">lambda</span> <span class="n">filename</span><span class="p">,</span> <span class="o">**</span><span class="n">kwds</span><span class="p">:</span> <span class="n">pd</span><span class="o">.</span><span class="n">read_excel</span><span class="p">(</span><span class="n">filename</span><span class="p">,</span> <span class="o">**</span><span class="n">kwds</span><span class="p">),</span>
            <span class="n">pd</span><span class="o">.</span><span class="n">read_excel</span><span class="p">)</span>
    <span class="p">},</span>
    <span class="s2">&quot;writers&quot;</span><span class="p">:</span> <span class="p">{</span>
        <span class="s2">&quot;.csv&quot;</span><span class="p">:</span> <span class="n">update_wrapper</span><span class="p">(</span>
            <span class="k">lambda</span> <span class="n">df</span><span class="p">,</span> <span class="o">**</span><span class="n">kwds</span><span class="p">:</span> <span class="n">df</span><span class="o">.</span><span class="n">to_csv</span><span class="p">(</span><span class="n">kwds</span><span class="o">.</span><span class="n">pop</span><span class="p">(</span><span class="s2">&quot;path&quot;</span><span class="p">),</span> <span class="o">**</span><span class="n">kwds</span><span class="p">),</span>
            <span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span><span class="o">.</span><span class="n">to_csv</span><span class="p">),</span>
        <span class="s2">&quot;.html&quot;</span><span class="p">:</span> <span class="n">update_wrapper</span><span class="p">(</span>
            <span class="k">lambda</span> <span class="n">df</span><span class="p">,</span> <span class="o">**</span><span class="n">kwds</span><span class="p">:</span> <span class="n">to_html</span><span class="p">(</span><span class="n">kwds</span><span class="o">.</span><span class="n">pop</span><span class="p">(</span><span class="s2">&quot;path&quot;</span><span class="p">),</span> <span class="n">df</span><span class="p">,</span> <span class="o">**</span><span class="n">kwds</span><span class="p">),</span>
            <span class="n">to_html</span><span class="p">),</span>
        <span class="s2">&quot;.pkl&quot;</span><span class="p">:</span> <span class="n">update_wrapper</span><span class="p">(</span>
            <span class="k">lambda</span> <span class="n">df</span><span class="p">,</span> <span class="o">**</span><span class="n">kwds</span><span class="p">:</span> <span class="n">df</span><span class="o">.</span><span class="n">to_pickle</span><span class="p">(</span><span class="n">kwds</span><span class="o">.</span><span class="n">pop</span><span class="p">(</span><span class="s2">&quot;path&quot;</span><span class="p">),</span> <span class="o">**</span><span class="n">kwds</span><span class="p">),</span>
            <span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span><span class="o">.</span><span class="n">to_pickle</span><span class="p">),</span>
        <span class="s2">&quot;.txt&quot;</span><span class="p">:</span> <span class="n">update_wrapper</span><span class="p">(</span>
            <span class="k">lambda</span> <span class="n">df</span><span class="p">,</span> <span class="o">**</span><span class="n">kwds</span><span class="p">:</span> <span class="n">df</span><span class="o">.</span><span class="n">to_csv</span><span class="p">(</span><span class="n">kwds</span><span class="o">.</span><span class="n">pop</span><span class="p">(</span><span class="s2">&quot;path&quot;</span><span class="p">),</span> <span class="n">sep</span><span class="o">=</span><span class="n">kwds</span><span class="o">.</span><span class="n">pop</span><span class="p">(</span><span class="s2">&quot;sep&quot;</span><span class="p">,</span> <span class="s2">&quot;</span><span class="se">\t</span><span class="s2">&quot;</span><span class="p">),</span> <span class="o">**</span><span class="n">kwds</span><span class="p">),</span>
            <span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span><span class="o">.</span><span class="n">to_csv</span><span class="p">),</span>
        <span class="s2">&quot;.xlsx&quot;</span><span class="p">:</span> <span class="n">update_wrapper</span><span class="p">(</span>
            <span class="k">lambda</span> <span class="n">df</span><span class="p">,</span> <span class="o">**</span><span class="n">kwds</span><span class="p">:</span> <span class="n">df</span><span class="o">.</span><span class="n">to_excel</span><span class="p">(</span><span class="n">kwds</span><span class="o">.</span><span class="n">pop</span><span class="p">(</span><span class="s2">&quot;path&quot;</span><span class="p">),</span> <span class="o">**</span><span class="n">kwds</span><span class="p">),</span>
            <span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span><span class="o">.</span><span class="n">to_excel</span><span class="p">)</span>
    <span class="p">}</span>
<span class="p">}</span>


<div class="viewcode-block" id="read">
<a class="viewcode-back" href="../../api/src.html#src.inout.read">[docs]</a>
<span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
    <span class="s2">&quot;-f&quot;</span><span class="p">,</span> <span class="s2">&quot;--filename&quot;</span><span class="p">,</span>
    <span class="nb">type</span><span class="o">=</span><span class="n">click</span><span class="o">.</span><span class="n">Path</span><span class="p">(</span><span class="n">exists</span><span class="o">=</span><span class="kc">True</span><span class="p">),</span>
    <span class="n">required</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span>
    <span class="n">help</span><span class="o">=</span><span class="s2">&quot;File to read in as a pandas.DataFrame based on the file extension.&quot;</span><span class="p">)</span>
<span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
        <span class="s2">&quot;-p&quot;</span><span class="p">,</span> <span class="s2">&quot;--params&quot;</span><span class="p">,</span>
        <span class="nb">type</span><span class="o">=</span><span class="nb">str</span><span class="p">,</span>
        <span class="n">default</span><span class="o">=</span><span class="s2">&quot;&quot;</span><span class="p">,</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;String of function options in the format &#39;param1=value1|param2=value2|...&#39;.&quot;</span><span class="p">)</span>
<span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
    <span class="s2">&quot;--format&quot;</span><span class="p">,</span>
    <span class="nb">type</span><span class="o">=</span><span class="n">click</span><span class="o">.</span><span class="n">Choice</span><span class="p">(</span><span class="nb">list</span><span class="p">(</span><span class="n">CONFIG</span><span class="p">[</span><span class="s2">&quot;readers&quot;</span><span class="p">]</span><span class="o">.</span><span class="n">keys</span><span class="p">()),</span> <span class="n">case_sensitive</span><span class="o">=</span><span class="kc">False</span><span class="p">),</span>
    <span class="n">help</span><span class="o">=</span><span class="s2">&quot;Explicitly specify the file extension. (Not usually necessary.)&quot;</span><span class="p">)</span>
<span class="nd">@generator</span>
<span class="k">def</span> <span class="nf">read</span><span class="p">(</span><span class="n">filename</span><span class="p">,</span> <span class="n">params</span><span class="p">,</span> <span class="nb">format</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;Read a pandas DataFrame from a file.&quot;&quot;&quot;</span>
    <span class="k">if</span> <span class="nb">format</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
        <span class="n">_</span><span class="p">,</span> <span class="n">ext</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">splitext</span><span class="p">(</span><span class="n">filename</span><span class="p">)</span>
        <span class="n">ext</span> <span class="o">=</span> <span class="n">ext</span><span class="o">.</span><span class="n">lower</span><span class="p">()</span>
        <span class="n">logging</span><span class="o">.</span><span class="n">debug</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;Reading file of type </span><span class="si">{</span><span class="n">ext</span><span class="si">!r}</span><span class="s2">&quot;</span><span class="p">)</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="n">ext</span> <span class="o">=</span> <span class="s2">&quot;.&quot;</span> <span class="o">+</span> <span class="nb">format</span><span class="o">.</span><span class="n">strip</span><span class="p">()</span><span class="o">.</span><span class="n">strip</span><span class="p">(</span><span class="s2">&quot;.&quot;</span><span class="p">)</span>
    <span class="n">reader</span> <span class="o">=</span> <span class="n">CONFIG</span><span class="p">[</span><span class="s2">&quot;readers&quot;</span><span class="p">][</span><span class="n">ext</span><span class="p">]</span>
    <span class="n">pd_params</span> <span class="o">=</span> <span class="n">params_to_dict</span><span class="p">(</span><span class="n">params</span><span class="p">)</span> <span class="k">if</span> <span class="n">params</span> <span class="k">else</span> <span class="nb">dict</span><span class="p">()</span>
    <span class="n">df</span> <span class="o">=</span> <span class="n">reader</span><span class="p">(</span><span class="n">filename</span><span class="p">,</span> <span class="o">**</span><span class="n">pd_params</span><span class="p">)</span>
    <span class="n">logging</span><span class="o">.</span><span class="n">debug</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;Reading </span><span class="si">{</span><span class="n">filename</span><span class="si">!r}</span><span class="s2"> with </span><span class="si">{</span><span class="n">reader</span><span class="o">.</span><span class="vm">__name__</span><span class="si">!r}</span><span class="s2"> with options </span><span class="si">{</span><span class="n">pd_params</span><span class="si">}</span><span class="s2">.&quot;</span><span class="p">)</span>
    <span class="k">yield</span> <span class="n">df</span><span class="o">.</span><span class="n">to_frame</span><span class="p">()</span> <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">df</span><span class="p">,</span> <span class="n">pd</span><span class="o">.</span><span class="n">Series</span><span class="p">)</span> <span class="k">else</span> <span class="n">df</span></div>



<div class="viewcode-block" id="write">
<a class="viewcode-back" href="../../api/src.html#src.inout.write">[docs]</a>
<span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
    <span class="s2">&quot;-f&quot;</span><span class="p">,</span> <span class="s2">&quot;--filename&quot;</span><span class="p">,</span>
    <span class="nb">type</span><span class="o">=</span><span class="n">click</span><span class="o">.</span><span class="n">Path</span><span class="p">(),</span>
    <span class="n">required</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span>
    <span class="n">help</span><span class="o">=</span><span class="s2">&quot;File into which the pandas.DataFrame should be written.&quot;</span><span class="p">)</span>
<span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
        <span class="s2">&quot;-p&quot;</span><span class="p">,</span> <span class="s2">&quot;--params&quot;</span><span class="p">,</span>
        <span class="nb">type</span><span class="o">=</span><span class="nb">str</span><span class="p">,</span>
        <span class="n">default</span><span class="o">=</span><span class="s2">&quot;&quot;</span><span class="p">,</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;String of function options in the format &#39;param1=value1|param2=value2|...&#39;.&quot;</span><span class="p">)</span>
<span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
    <span class="s2">&quot;--format&quot;</span><span class="p">,</span>
    <span class="nb">type</span><span class="o">=</span><span class="n">click</span><span class="o">.</span><span class="n">Choice</span><span class="p">(</span><span class="nb">list</span><span class="p">(</span><span class="n">CONFIG</span><span class="p">[</span><span class="s2">&quot;writers&quot;</span><span class="p">]</span><span class="o">.</span><span class="n">keys</span><span class="p">()),</span> <span class="n">case_sensitive</span><span class="o">=</span><span class="kc">False</span><span class="p">),</span>
    <span class="n">help</span><span class="o">=</span><span class="s2">&quot;Explicitly specify the file extension. (Not usually necessary.)&quot;</span><span class="p">)</span>
<span class="nd">@processor</span>
<span class="k">def</span> <span class="nf">write</span><span class="p">(</span><span class="n">dfs</span><span class="p">,</span> <span class="n">filename</span><span class="p">,</span> <span class="n">params</span><span class="p">,</span> <span class="nb">format</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;Write a pandas DataFrame to a file.&quot;&quot;&quot;</span>
    <span class="k">for</span> <span class="n">df</span> <span class="ow">in</span> <span class="n">dfs</span><span class="p">:</span>
        <span class="k">if</span> <span class="nb">format</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
            <span class="n">_</span><span class="p">,</span> <span class="n">ext</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">splitext</span><span class="p">(</span><span class="n">filename</span><span class="p">)</span>
            <span class="n">ext</span> <span class="o">=</span> <span class="n">ext</span><span class="o">.</span><span class="n">lower</span><span class="p">()</span>
            <span class="n">logging</span><span class="o">.</span><span class="n">debug</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;Reading file of type </span><span class="si">{</span><span class="n">ext</span><span class="si">!r}</span><span class="s2">&quot;</span><span class="p">)</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">ext</span> <span class="o">=</span> <span class="s2">&quot;.&quot;</span> <span class="o">+</span> <span class="nb">format</span><span class="o">.</span><span class="n">strip</span><span class="p">()</span><span class="o">.</span><span class="n">strip</span><span class="p">(</span><span class="s2">&quot;.&quot;</span><span class="p">)</span>
        <span class="n">writer</span> <span class="o">=</span> <span class="n">CONFIG</span><span class="p">[</span><span class="s2">&quot;writers&quot;</span><span class="p">][</span><span class="n">ext</span><span class="p">]</span>
        <span class="n">pd_params</span> <span class="o">=</span> <span class="n">params_to_dict</span><span class="p">(</span><span class="n">params</span><span class="p">)</span> <span class="k">if</span> <span class="n">params</span> <span class="k">else</span> <span class="nb">dict</span><span class="p">()</span>
        <span class="n">pd_params</span><span class="p">[</span><span class="s2">&quot;path&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">filename</span>
        <span class="n">writer</span><span class="p">(</span><span class="n">df</span><span class="p">,</span> <span class="o">**</span><span class="n">pd_params</span><span class="p">)</span>
        <span class="n">logging</span><span class="o">.</span><span class="n">debug</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;Writing </span><span class="si">{</span><span class="n">filename</span><span class="si">!r}</span><span class="s2"> to </span><span class="si">{</span><span class="n">writer</span><span class="o">.</span><span class="vm">__name__</span><span class="si">!r}</span><span class="s2"> with options </span><span class="si">{</span><span class="n">pd_params</span><span class="si">}</span><span class="s2">.&quot;</span><span class="p">)</span>
        <span class="k">yield</span></div>

</pre></div>

          </div>
          
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<h1 class="logo"><a href="../../index.html">pandas</a></h1>








<h3>Navigation</h3>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../pandas.html">Reference</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../license.html">License</a></li>
</ul>

<div class="relations">
<h3>Related Topics</h3>
<ul>
  <li><a href="../../index.html">Documentation overview</a><ul>
  <li><a href="../index.html">Module code</a><ul>
  </ul></li>
  </ul></li>
</ul>
</div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>document.getElementById('searchbox').style.display = "block"</script>








        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="footer">
      &copy;2023, Branden Kappes.
      
      |
      Powered by <a href="http://sphinx-doc.org/">Sphinx 7.2.6</a>
      &amp; <a href="https://github.com/bitprophet/alabaster">Alabaster 0.7.13</a>
      
    </div>

    

    
  </body>
</html>